#pragma once

#include "cksm_inc.h"

typedef struct
{
    struct list_head list;
    int pid;
    unsigned long vm_start;
    unsigned long vm_end;
    int crc32;
    int is_present;
} memory_list;

void init_list(memory_list * lst);
void add_entry(memory_list * lst, int pid, unsigned long vm_start, unsigned long vm_end, int crc32);
void del_entry(memory_list * lst, int pid, unsigned long vm_start, unsigned long vm_end, int crc32);
void clean_list(memory_list * lst);
memory_list * find_entry(memory_list * lst, int pid, unsigned long vm_start, unsigned long vm_end);
void show_list(memory_list * lst);
void del_unused_entries(memory_list * lst, int pid);
void zero_is_present(memory_list * lst, int pid);
